
accessid = ''
accesskey = ''
host = ''
policyBase64 = ''
signature = ''
callbackbody = ''
filename = ''
key = ''
expire = 0
g_object_name = ''
g_object_name_type = ''
now = timestamp = Date.parse(new Date()) / 1000; 
$("#image_sfz_zm_image").attr("src","/resources/images/yt/sf_zm.gif");
$("#image_sfz_bm_image").attr("src","/resources/images/yt/sf_bj.gif");
$("#image_sfz_sc_image").attr("src","/resources/images/yt/sf_sc.jpg");
$("#yhk_image").attr("src","/resources/images/yt/yhk.jpg");


function send_request()
{
    var xmlhttp = null;
    if (window.XMLHttpRequest)
    {
        xmlhttp=new XMLHttpRequest();
    }
    else if (window.ActiveXObject)
    {
        xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
  
    if (xmlhttp!=null)
    {
    	debugger;
        serverUrl = '/upload/getKey';
        xmlhttp.open( "GET", serverUrl, false );
        xmlhttp.send( null );
        return xmlhttp.responseText
    }
    else
    {
        alert("Your browser does not support XMLHTTP.");
    }
};

function check_object_radio() {

     g_object_name_type = "random_name";

}

function get_signature()
{
    //可以判断当前expire是否超过了当前时间,如果超过了当前时间,就重新取一下.3s 做为缓冲
    now = timestamp = Date.parse(new Date()) / 1000; 
    if (expire < now + 3)
    {
        body = send_request()
        var obj = eval ("(" + body + ")");
        host = obj['host']
        policyBase64 = obj['policy']
        accessid = obj['accessid']
        signature = obj['signature']
        expire = parseInt(obj['expire'])
        callbackbody = obj['callback'] 
        key = obj['dir']
        return true;
    }
    return false;
};

function random_string(len) {
	len = len || 32;
	var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';   
	var maxPos = chars.length;
	var pwd = '';
	for (i = 0; i < len; i++) {
		pwd += chars.charAt(Math.floor(Math.random() * maxPos));
    }
    return pwd;
}

function get_suffix(filename) {
    pos = filename.lastIndexOf('.')
    suffix = ''
    if (pos != -1) {
        suffix = filename.substring(pos)
    }
    return suffix;
}

function calculate_object_name(filename)
{
    if (g_object_name_type == 'local_name')
    {
        g_object_name += "${filename}"
    }
    else if (g_object_name_type == 'random_name')
    {
        suffix = get_suffix(filename)
        var cardNumInfoInput=$('#cardNum').val();
        
        var oDate = new Date(); //实例一个时间对象；
        var year=oDate.getFullYear();   //获取系统的年；
        var month=oDate.getMonth()+1;   //获取系统月份，由于月份是从0开始计算，所以要加1
        var date=oDate.getDate(); // 获取系统日，
        var hour=oDate.getHours(); //获取系统时，
        var minutes=oDate.getMinutes(); //分
        var seconds=oDate.getSeconds(); //秒
        
        if (tempurlto=='image_sfz_zm') {
        	 g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_0";
    	} else if(tempurlto=='image_sfz_bm'){
    		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_1";
    	}else if(tempurlto=='image_sfz_sc'){
    		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_2";
    	}else if(tempurlto=='yhk'){
    		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_3";
    	}else{
    		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_-1";
    	}
        debugger;
       // g_object_name = key + random_string(10) + suffix
        g_object_name = key + g_object_name + suffix
    }
    return ''
}

function get_uploaded_object_name(filename)
{
    if (g_object_name_type == 'local_name')
    {
        tmp_name = g_object_name
        tmp_name = tmp_name.replace("${filename}", filename);
        return tmp_name
    }
    else if(g_object_name_type == 'random_name')
    {
        return g_object_name
    }
}

function set_upload_param(up, filename, ret)
{
    if (ret == false)
    {
        ret = get_signature()
    }
    //g_object_name = key;
    debugger;
    var cardNumInfoInput=$('#cardNum').val();
    var oDate = new Date(); //实例一个时间对象；
    var year=oDate.getFullYear();   //获取系统的年；
    var month=oDate.getMonth()+1;   //获取系统月份，由于月份是从0开始计算，所以要加1
    var date=oDate.getDate(); // 获取系统日，
    var hour=oDate.getHours(); //获取系统时，
    var minutes=oDate.getMinutes(); //分
    var seconds=oDate.getSeconds(); //秒
    if (tempurlto=='image_sfz_zm') {
    	 g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_0";
	} else if(tempurlto=='image_sfz_bm'){
		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_1";
	}else if(tempurlto=='image_sfz_sc'){
		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_2";
	}else if(tempurlto=='yhk'){
		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_3";
	}else{
		g_object_name=cardNumInfoInput+"_"+year+month+date+hour+"_-1";
	}
   
    if (filename != '') { suffix = get_suffix(filename)
        calculate_object_name(filename)
    }
    new_multipart_params = {
        'key' : g_object_name,
        'policy': policyBase64,
        'OSSAccessKeyId': accessid, 
        'success_action_status' : '200', //让服务端返回200,不然，默认会返回204
        'callback' : callbackbody,
        'signature': signature
    };
debugger;
    up.setOption({
        'url': host,
        'multipart_params': new_multipart_params
    });

    up.start();
}
var uploader = new plupload.Uploader({
	runtimes : 'html5,flash,silverlight,html4',
	browse_button : 'selectfiles', 
    multi_selection: false,
	container: document.getElementById('container'),
	flash_swf_url : '/resources/js/show/plupload-2.1.2/Moxie.swf',
	silverlight_xap_url : '/resources/js/show/plupload-2.1.2/Moxie.xap',
    url : 'https://oss.aliyuncs.com',
    filters: {
        mime_types : [ //只允许上传图片和zip文件
        { title : "Image files", extensions : "jpg,gif,png,bmp",mimeTypes: 'image/jpg,image/jpeg,image/png,image/gif' }
        ],
        max_file_size : '10mb', //最大只能上传10mb的文件
        min_file_size :'500kb',
        prevent_duplicates : false //允许选取重复文件
    },

	init: {
		PostInit: function() {
			document.getElementById('ossfile').innerHTML = '';
			
			document.getElementById('postfiles').onclick = function() {
            set_upload_param(uploader, '', false);
            return false;
			};
		},

		FilesAdded: function(up, files) {
			plupload.each(files, function(file) {
				document.getElementById('ossfile2').innerHTML += '<div id="' + file.id + '">' + file.name + ' (' + plupload.formatSize(file.size) + ')<b></b>'
				+'<div class="progress"><div class="progress-bar" style="width: 0%"></div></div>'
				+'</div>';
			});
		},

		BeforeUpload: function(up, file) {
            check_object_radio();
            set_upload_param(up, file.name, true);
        },

		UploadProgress: function(up, file) {
			
			var d = document.getElementById("tt");
			d.getElementsByTagName('b')[0].innerHTML = '<span>' + file.percent + "%</span>";
//            var prog = d.getElementsByTagName('div')[0];
//			var progBar = prog.getElementsByTagName('div')[0];
//			progBar.style.width= 2*file.percent+'px';
//			progBar.setAttribute('aria-valuenow', file.percent);
		},

		FileUploaded: function(up, file, info) {
			debugger;
            if (info.status == 200)
            {
                //document.getElementById(file.id).getElementsByTagName('b')[0].innerHTML = 'upload to oss success, object name:' + get_uploaded_object_name(file.name) + ' 回调服务器返回的内容是:' + info.response;
                //设置路径
            	document.getElementById(file.id).getElementsByTagName('b')[0].innerHTML = '上传照片成功';
            	document.getElementById(tempurlto+"_image").src="https://cddz-card.oss-cn-beijing.aliyuncs.com/"+get_uploaded_object_name(file.name);
            	document.getElementById(tempurlto+"_text").value=get_uploaded_object_name(file.name);
            }
            else if (info.status == 203)
            {
                document.getElementById(file.id).getElementsByTagName('b')[0].innerHTML = '上传到OSS成功，但是oss访问用户设置的上传回调服务器失败，失败原因是:' + info.response;
            }
            else
            {
                document.getElementById(file.id).getElementsByTagName('b')[0].innerHTML = info.response;
            } 
		},

		Error: function(up, err) {
            if (err.code == -600) {
                document.getElementById('console').appendChild(document.createTextNode("\n选择的文件太大了,可以根据应用情况，在upload.js 设置一下上传的最大大小"));
            }
            else if (err.code == -601) {
                document.getElementById('console').appendChild(document.createTextNode("\n选择的文件后缀不对,可以根据应用情况，在upload.js进行设置可允许的上传文件类型"));
            }
            else if (err.code == -602) {
                document.getElementById('console').appendChild(document.createTextNode("\n这个文件已经上传过一遍了"));
            }
            else if(err.code== -200){
            	document.getElementById('console').appendChild(document.createTextNode("\nHTTP 异常"));
            }
            else 
            {
             //   document.getElementById('console').appendChild(document.createTextNode("\nError xml:" + err.response));
            }
		}
	}
});

uploader.init();

